UNIT BEANLEIT;

(* ******************************************************************** *)
(* K L A S S E : TBedAnleitung                                          *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.1                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel I, 10997 Berlin             *)
(*                                                                      *)
(* Dateiname   : beanleit.pas                                           *)
(*                                                                      *)
(* Aufgabe     : stellt die Bedienungsanleitung zur Verfuegung.         *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : V. 1.0   20-NOV-97   Schulversion                      *)
(*             :    2.0   20-NOV-97   Vollversion                       *)
(*             :    3.1   01-FEB-98   BILDSCHIRM, GRAFIK eingebunden    *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES FENSTER;

type
  TBedAnleitung = object (CFenster)
                    constructor Init (sp, zei,lae, br, einRahmen : integer;
                                      einTitel : string);
                    procedure Zeigen;        virtual;
                    procedure WartungZeigen; virtual;
                  end;

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse    : CFenster
Bezugsklassen : BILDSCHIRM, GRAFIK
Module        : -


Methoden
--------

Zeigen

  Aufgabe: Bedienung und Geldtasten erklaeren
  vorher : -
  nachher: Bedienungsanleitung steht auf dem Bildschirm

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)
USES
    BILDSCHIRM,
    GRAFIK;

constructor TBedAnleitung.Init (sp, zei, lae, br, einRahmen : integer; einTitel : string);
(* -------------------------------------------------------------------- *)
begin
  CFenster.Init(sp,zei,lae,br,einRahmen,einTitel);
end;


procedure TBedAnleitung.Zeigen;
(* -------------------------------------------------------------------- *)
begin
  CFenster.Zeigen;
  Screen.Cursor (XPos+2, YPos+1); write (' F A H R S C H E I N E');
  Screen.Cursor (XPos+2, YPos+3); write ('1. Fahrschein auswhlen');
  Screen.Cursor (XPos+2, YPos+4); write ('2. Geldbetrag eingeben');
  Screen.Cursor (XPos+2, YPos+6); write ('   g :  0.10  DM');
  Screen.Cursor (XPos+2, YPos+7); write ('   f :  0.50  DM');
  Screen.Cursor (XPos+2, YPos+8); write ('   m :  1.00  DM');
  Screen.Cursor (XPos+2, YPos+9); write ('   z :  2.00  DM');
  Screen.Cursor (XPos+2, YPos+10);write ('   F :  5.00  DM');
  Screen.Cursor (XPos+2, YPos+12);write ('3. Fahrschein und');
  Screen.Cursor (XPos+2, YPos+13);write ('   Rckgeld entnehmen');
end;


procedure TBedAnleitung.WartungZeigen;
(* -------------------------------------------------------------------- *)
const
   sp = 21;
   zei=  8;
   txtsp = 22;
   txtzei= 10;

var
  Flaeche : CFlaeche;

begin
   Screen.Leeren;
   Screen.FarbeSetzen(BLAU);
   Flaeche.Init (sp,zei,40,14);
   Flaeche.FarbeSetzen(SCHWARZ);   (* der Schatten *)
   Flaeche.Zeigen;
   Flaeche.Init (sp-1,zei - 1,40,14);
   Flaeche.FarbeSetzen(GELB);
   Flaeche.Zeigen;
   Screen.Cursor(txtsp+9,txtzei-2);write(' - W A R T U N G -  ');
   Screen.Cursor(txtsp,txtzei);  write(' Strungen und Fehler des Programms  ');
   Screen.Cursor(txtsp,txtzei+1);write(' bitte melden bei                    ');
   Screen.Cursor(txtsp,txtzei+3);write('          S. Spolwig                 ');
   Screen.Cursor(txtsp,txtzei+4);write('          c/o OSZ -Handel-           ');
   Screen.Cursor(txtsp,txtzei+5);write('          Wrangelstr. 96             ');
   Screen.Cursor(txtsp,txtzei+6);write('          10997 Berlin               ');
   Screen.Cursor(txtsp,txtzei+8);write(' E-Mail: spolwig@oszhdl.be.schule.de ');
   Screen.TextfarbeSetzen(SCHWARZ);
   Screen.HintergrundfarbeSetzen(GELB);
   Screen.Cursor(txtsp, txtzei+10) ; write('(c) 1997');
   Screen.CursorHome;
end; (* wartung *)


BEGIN
END. (* BEANLEIT *)
