UNIT DISPL;

(* ******************************************************************** *)
(* K L A S S E : TDisplay                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.2                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : display.pas                                            *)
(*                                                                      *)
(* Aufgabe     : stellt das Objekt Display zur Ausgabe von Text und     *)
(*               Betraegen zur Verfuegung.                              *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : V. 1.1  27-JAN-98  var Display (globales Objekt) hinzu-*)
(*                                  gefuegt                             *)
(* Version     :    3.2  01-FEB-98  BILDSCHIRM, GRAFIK eingebunden      *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES
    TXTBOX;

type
  TDisplay = object (CTextbox)
               Zahl : real;

               constructor Init (sp,zei,lae,br, einRahmen : integer;
                                 einTitel : string);
               procedure TextZeigen (einText : string) ; virtual;
               procedure ZahlZeigen (eineZahl : real)  ; virtual;
             end;

var Display : TDisplay;  (* damit kann ein Exemplar von ueberall benutzt werden *)

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse     : CTxtbox
Bezugsklassen  : BILDSCHIRM
benutzte Module: -

Methoden
--------

TextZeigen (einText : string)

  Aufgabe: Texte in roter Schrift im Display ausgeben.
  vorher : init.
  nachher: -


ZahlZeigen (eineZahl : real)

  Aufgabe: Betraege in roter Schrift im Display ausgeben.
  vorher : init.
  nachher: -

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)
USES
  BILDSCHIRM;


constructor TDisplay.Init (sp,zei,lae,br, einRahmen : integer; einTitel : string);
(* -------------------------------------------------------------------- *)
begin
  CTextbox.Init(sp,zei,lae,br,einRahmen,einTitel);
end;


procedure TDisplay.TextZeigen (einText : string);
(* -------------------------------------------------------------------- *)
begin
  Text := einText ;
  Screen.TextfarbeSetzen (ROT);
  Screen.Cursor (XPos+3, YPos + 2); write(Text);
  Screen.CursorHome;
  Screen.NormalVideo;
end;


procedure TDisplay.ZahlZeigen (eineZahl : real);
(* -------------------------------------------------------------------- *)
begin
  Zahl := eineZahl;
  Screen.TextfarbeSetzen(ROT);
  Screen.Cursor(XPos + (Laenge - 7), YPos + 2); write (Zahl:2:2);
  Screen.CursorHome;
  Screen.NormalVideo;
end;


BEGIN
END. (* DISPLAY *)