UNIT FSGEBER;

(* ******************************************************************** *)
(* K L A S S E : TFSGeber                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.1                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : fsgeber.pas                                            *)
(*                                                                      *)
(* Aufgabe     : stellt das Bauteil zur Ausgabe von Fahrscheinen dar.   *)
(*               Er bereitet den gewaehlten Fahrschein mit dem entspre- *)
(*               chenden Aufdruck vor und druckt ihn aus (am Bildschirm)*)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : V. 1.1   23-JAN-98  InitFahrschein mit Tarif, Preis    *)
(* Version     :    3.1   01-FEB-98  BILDSCHIRM, GRAFIK eingebunden     *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES GEBER,
     FSCHEIN;

type
  TFSGeber = object (CGeber)
               Fahrschein : CFahrschein;

               constructor Init (sp,zei,lae,br, einRahmen : integer;
                                 einTitel : string);

               procedure InitFahrschein (einTarif, einPreis : word); virtual;
               procedure Auswerfen ;                         virtual;
               procedure Leeren;                             virtual;
             end;

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse     : CGeber
Bezugsklassen  : CFahrschein
benutzte Module: -


Methoden
--------

Init (sp,zei,lae,br, einRahmen : integer ; einTitel : string);

  Aufgabe : FSGeber initialisieren
            aufrufen
  vorher  : -
  nachher : -


InitFahrschein (einTarif, einPreis : word)

  Aufgabe: Fahrscheine entsprechend dem gewaehlten Tarif vorbereiten
  vorher : -
  nachher: Fahrschein ist mit Bezeichnung, Preis und Tarif initialisiert


Auswerfen

  Aufgabe : Fahrschein gemaess Tarifwahl auf dem Bildschirm ausgeben.
  vorher  : init.
  nachher : -


Leeren

  Aufgabe : Fahrscheinanzeige aus dem Bildschirm loeschen
  vorher  : init.
  nachher : FSGeber wird leer dargestellt


----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)

constructor TFSGeber.Init (sp,zei,lae,br, einRahmen : integer; einTitel : string);
(* -------------------------------------------------------------------- *)
begin
  CGeber.Init (sp,zei,lae,br, einRahmen, einTitel);
end;


procedure TFSGeber.InitFahrschein (einTarif, einPreis : word);
(* -------------------------------------------------------------------- *)
begin
  Fahrschein.Init(XPos+2,YPos+2,15,7,2,'');

  case einTarif of

    0 : begin
          Fahrschein.TarifInit (einTarif, einPreis, '');
        end;

    1 : begin
          Fahrschein.TarifInit (einTarif, einPreis, 'NORMAL-TARIF');
        end;

    2 : begin
          Fahrschein.TarifInit (einTarif, einPreis, 'KURZSTRECKE');
        end;

    3 : begin
          Fahrschein.TarifInit (einTarif, einPreis, 'SAMMELKARTE');
        end;
  end;  (* case *)
end;


procedure TFSGeber.Auswerfen;
(* -------------------------------------------------------------------- *)
begin
  Fahrschein.Zeigen;
end;


procedure TFSGeber.Leeren;
(* -------------------------------------------------------------------- *)
begin
  Fahrschein.Loeschen;
  Zeigen;
end;


BEGIN
END.