UNIT GEBER;

(* ******************************************************************** *)
(* K L A S S E : GEBER                                                  *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.2                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : geber.pas                                              *)
(*                                                                      *)
(* Aufgabe     : stellt das Grundmodell fuer eine Ausgabeeinheit zur    *)
(*               Verfuegung. Fahrscheingeber und Muenzgeber koennen     *)
(*               davon abgeleitet werden. Es soll keine abstrakte Klasse*)
(*               sein.                                                  *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : -                                                      *)
(*             : V. -  3.2  01-FEB-98  BILDSCHIRM, GRAFIK eingebunden   *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES FENSTER,
     GRAFIK;

type
  CGeber = object (CFenster)
             Klappe : CFlaeche;
             constructor Init (sp,zei,lae,br, einRahmen : integer;
                               einTitel : string);

             procedure Zeigen; virtual;
             procedure Leeren; virtual;
           end;


(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse   : -
Bezugsklassen: CBildschirm, GRAFIK
benutzte Module: -

Methoden
--------

Init

  Auftrag: Alle Attribute festlegen
  vorher : -
  nachher: Position,Groesse, Rahmen und Titel sind uebergeben


Zeigen

  Auftrag: Geber auf dem Bildschirm zeigen.
  vorher : init.
  nachher: Geber steht auf dem Bildschirm


Leeren;

  Auftrag: Angezeigtes Objekt aus dem Geber loeschen
  vorher : Bildschirm ist Hellgrau
  nachher: Geberflaeche ist leer

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)
USES
   BILDSCHIRM;


constructor CGeber.Init (sp,zei,lae,br, einRahmen : integer; einTitel : string);
(* -------------------------------------------------------------------- *)
begin
  CFenster.Init (sp,zei,lae,br, einRahmen, einTitel);
  Klappe.Init (XPos+1, YPos+1, Laenge - 2, Hoehe - 2);
  Klappe.FarbeSetzen(BLAU);
  Klappe.ZeichenSetzen(chr(178));       
  Klappe.ZeichenFarbeSetzen(SCHWARZ);
end;


procedure CGeber.Zeigen;
(* -------------------------------------------------------------------- *)
var Flaeche : CFlaeche;

begin
  CFenster.Zeigen;
  KLappe.Zeigen;
end;


procedure CGeber.Leeren;
(* -------------------------------------------------------------------- *)
begin
  Klappe.Zeigen;
end;

BEGIN
END. (* GEBER *)