UNIT MUENZE;

(* ******************************************************************** *)
(* K L A S S E : TMuenze                                                *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.1                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig (OSZ-Handel I)  10997 Berlin            *)
(*                                                                      *)
(* Dateiname   : muenze.pas                                             *)
(*                                                                      *)
(* Aufgabe     : stellt das Objekt Muenze dar.                          *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   :V.   3.1  01-FEB-98  BILDSCHIRM, GRAFIK eingebunden     *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES BILDSCHIRM,
     GRAFIK,
     FENSTER;

type
  TMuenze = object (CFLaeche)
              Wert        : 0..500;  (* in Pfennig *)
              Praegung    : string;

              constructor Init (eineLaenge, einWert : integer; einePraegung :string;
                                eineFarbe : TFarben);

              procedure PositionSetzen (neuX, neuY : integer); virtual;
              procedure VersetzenUm (X, Y : integer); virtual;
              procedure Zeigen;                       virtual;
              function  IstEcht : boolean;            virtual;
              function  HatWert : integer;            virtual;
             end;


(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse     : CFlaeche
Bezugsklassen  : BILDSCHIRM
benutzte Module: -

Methoden
--------

Init

  Auftrag : Alle Attribute festlegen
  vorher  : -
  nachher : Attribute sind uebergeben

Zeigen

  Auftrag : Muenze auf dem Bildschirm zeigen.
  vorher  : init.
  nachher : Muenze steht auf dem Bildschirm


VersetzenUm (X, Y : integer)

  Auftrag : Muenze auf dem Bildschirm bewegen
  vorher  : init.
  nachher : Muenze ist von der alten Position um X nach  XPos
            und um Y nach YPos verschoben


PositionSetzen (neuX, neuY : integer); virtual;

  Auftrag : Position der Muenze festlegen
  vorher  : init.
  nachher : XPos und YPos sind festgelegt



IstEcht

  Anfrage : Pruefen, ob die Muenze echt ist
  vorher  : init.
  nachher : ist wahr, wenn die Farbe Tuerkis ist.



HatWert

  Anfrage : nach dem Wert der Muenze
  vorher  : init.
  nachher : Wert ist zurueckgeliefert

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)

constructor TMuenze.Init (eineLaenge, einWert : integer; einePraegung :string;
                          eineFarbe : TFarben);
(* -------------------------------------------------------------------- *)
begin
  CFlaeche.Init (1,1,eineLaenge,1);
  Farbe    := eineFarbe;
  Wert     := einWert;
  Praegung := einePraegung;
end;


procedure TMuenze.PositionSetzen(neuX, neuY : integer);
(* -------------------------------------------------------------------- *)
begin
  XPos := neuX;
  YPos := neuY;
end;


procedure TMuenze.Zeigen;
(* -------------------------------------------------------------------- *)
begin
  CFlaeche.Zeigen;
  Screen.HintergrundFarbeSetzen (Farbe);
  Screen.Cursor (XPos,YPos); write(Praegung);
  Screen.NormalVideo;
  Screen.CursorHome;
end;


procedure TMuenze.VersetzenUm (X, Y : integer);
(* -------------------------------------------------------------------- *)
begin
  Loeschen;
  XPos  := XPos + X;
  YPos  := YPos + Y;
  Zeigen;
end;


function TMuenze.IstEcht : boolean;
(* -------------------------------------------------------------------- *)
begin
  IstEcht := false;
  if Farbe = TUERKIS
  then IstEcht := true;
end;


function TMuenze.HatWert : integer;
(* -------------------------------------------------------------------- *)
begin
  HatWert := Wert;
end;


BEGIN
END. (* MUENZE *)