UNIT STEUEREINHEIT;

(* ******************************************************************** *)
(* K L A S S E : TSteuereinheit                                         *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.2                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : steuereinheit.pas                                      *)
(*                                                                      *)
(* Aufgabe     : STEUEREINHEIT vereint alle Komponenten des Fahr-       *)
(*               scheinautomaten, um den Ablauf von der Geldannahme bis *)
(*               zur Ausgabe von Rueckgeld und Fahrschein zu regeln.    *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : V.1.0 - 30-JAN-98  -                                   *)
(*             :   3.2 - 11-OKT-98  BILDSCHIRM, GRAFIK eingebunden      *)
(* ******************************************************************** *)


INTERFACE
(* ========================== Export ================================== *)

USES FENSTER,
     BEANLEIT,
     DISPL,
     TARLISTE,
     WAEHLER,
     FSGEBER,
     MGEBER;


type
  TSteuereinheit = object
                     Programmrahmen      : CFenster;
                     FahrscheinGeber     : TFsGeber;
                     Muenzgeber          : TMuenzgeber;
                     Waehler             : TWaehler;
                     Tarifliste          : TTarifliste;
                     Bedienungsanleitung : TBedAnleitung;

                     constructor Init;
                     procedure Ausfuehren; virtual;
                     procedure Beenden;    virtual;
                   end;

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse     : CFenster
Bezugsklassen  : CDisplay  import: Display, CBildschirm
                 CFahrschein, CFSGeber, CTarliste, CWaehler, CBedAnleitung,
                 CMuenzgeber
benutzte Module: CRT


Methoden
--------

Init

  Aufgabe : Alle Teile (Objekte) des Fahrscheinautomaten initialisieren.
  vorher  : -
  nachher : -


Ausfuehren

  Aufgabe : Gesamte Benutzungsoberflaeche zeigen und den Ablauf steuern bis
            die Abbruftaste (ESC) gedrueckt wurde.
  vorher  : init.
  nachher : Programm ist beendet.


Beenden

  Aufgabe : Kundendienst anzeigen und Bildschirm loeschen
  vorher  : Abbruchtaste ist gedrueckt
  nachher : Bildschirm ist leer.

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)

USES CRT,
     BILDSCHIRM;


constructor TSteuereinheit.Init;
(* -------------------------------------------------------------------- *)
begin
  Programmrahmen.Init(1,1,79,25, 2 , ' B  V  B  ');
  Bedienungsanleitung.Init(5,3,26,15,2,'');
  FahrscheinGeber.Init(52,15,20,4,2,'');
  Display.Init(43,3,35,5,4,'');
  Muenzgeber.Init(3,20,43,5,2,'');
  Waehler.Init(47,8,28,6,3,'Tarifwahl');
  Tarifliste.Init;
end;


procedure TSteuereinheit.Ausfuehren;
(* -------------------------------------------------------------------- *)
var
  stop  : char;
  Tarif : word;


begin
  Programmrahmen.Zeigen;
  Bedienungsanleitung.Zeigen;

  Display.Zeigen;
  Waehler.Zeigen;

  Muenzgeber.Zeigen;
  Fahrscheingeber.Zeigen;


  Waehler.Eingeben ;

  Tarif := Waehler.TarifHolen;

  while Tarif <> 0 do
  begin
    Fahrscheingeber.InitFahrschein(Tarif, Tarifliste.AktuellerPreis (Tarif));
    Muenzgeber.GeldAnnehmen (Tarifliste.AktuellerPreis (Tarif));
    Muenzgeber.RueckgeldAuszahlen;
    FahrscheinGeber.Auswerfen;

    stop := readkey;

    FahrscheinGeber.Leeren;
    Muenzgeber.Leeren;

    Waehler.Eingeben;
    Tarif := Waehler.TarifHolen;
  end;
end;


procedure TSteuereinheit.Beenden;
(* -------------------------------------------------------------------- *)
var stop : char;

begin
  Bedienungsanleitung.WartungZeigen;
  stop := readkey;
  Screen.Leeren;
end;


BEGIN
END. (* STEUEREINHEIT *)