UNIT TARLISTE;

(* ******************************************************************** *)
(* K L A S S E : TTarifListe                                            *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.0                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : tarliste.pas                                           *)
(*                                                                      *)
(* Aufgabe     : Die Tarifliste enthaelt die zu der Tarifnummer gehoe-  *)
(*               rigen Fahrscheinpreise.                                *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : 22-JAN-98                                              *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

const MAXLISTE = 10;

type
  TTarifListe = object
                  Preise : array [0..MAXLISTE] of Word;

                  constructor Init;
                  function  AktuellerPreis (tar : integer) : integer; virtual;
                end;

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse   : -
Bezugsklassen: -
Module       : -


Methoden
--------

Init

  Auftrag: Alle Preise festlegen
  vorher : -
  nachher: Preise sind zugewiesen


AktuellerPreis (tar : integer)

  Anfrage: nach dem zu tar gehrigen Preis
  vorher : init.
  nachher: liefert Preis zurueck


AnzahlPreise

  Anfrage: nach der Menge der gueltigen Tarifpreise
  vorher : init.
  nachher: liefert Anzahl zurueck
----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)

constructor TTarifListe.Init ;
(* -------------------------------------------------------------------- *)
var i : integer;

begin
  for i := 0 to MAXLISTE do (* erstmal alles leer *)
  begin
     Preise[i] := 0;
  end;

  Preise[1] :=  370;   (* alle Preis in Pfennig *)
  Preise[2] :=  150;
  Preise[3] := 1250;
end;


function TTarifListe.AktuellerPreis (tar : integer) : integer;
(* -------------------------------------------------------------------- *)
begin
  AktuellerPreis := Preise[tar] ;
end;


BEGIN
END.