UNIT WAEHLER;

(* ******************************************************************** *)
(* K L A S S E : TWaehler                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.1                                                    *)
(*                                                                      *)
(* Autor       : (c) S. Spolwig, OSZ Handel, 10997 Berlin               *)
(*                                                                      *)
(* Dateiname   : waehler.pas                                            *)
(*                                                                      *)
(* Aufgabe     : WAEHLER stellt die Einheit fuer die Tasteneingabe zur  *)
(*               Auswahl des Tarifs dar.                                *)
(*                                                                      *)
(* Compiler    : Turbo Pascal 7.0 / MSDOS                               *)
(* Aenderung   : 3.0 -  28-JAN-98   Steuerung ausgelagert               *)
(*             : 3.1    01-FEB-98   BILDSCHIRM, GRAFIK eingebunden      *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)

USES FENSTER;

type
  TWaehler = object (CFenster)
                    Tarif : word;
                    TasteGedrueckt : boolean;

                    constructor Init (sp,zei,lae,br, einRahmen : integer ; einTitel : string);
                    procedure Eingeben;          virtual;
                    procedure Zeigen;            virtual;
                    procedure AuswahlAnzeigen;   virtual;
                    function  TarifHolen : word; virtual;
                  end;

(*  ----------------- B e s c h r e i b u n g -------------------------

Oberklasse     : CFenster
Bezugsklassen  : CDisplay
benutzte Module: ASCII, CRT


Methoden
--------

Init

  Aufgabe : Waehler initialisieren
  vorher  : -
  nachher : -


Eingeben

  Aufgabe : Die Tarifauswahl des Benutzers annehmen
  vorher  : init.
  nachher : Tarif ist definiert


AuswahlAnzeigen

  Aufgabe : Gewaehlten Tarif optisch hervorheben
  vorher  : init.
  nachher : Tarifnummer ist auf hellem Hintergrund


Zeigen

  Aufgabe : Auswahl-Menue auf dem Bildschirm anzeigen
  vorher  : init.
  nachher : -


TarifHolen

  Anfrage: nach aktuellem Tarif
  vorher : Tarif ist initialisiert und eingegeben
  nachher: -

----------------------------------------------------------------------- *)


IMPLEMENTATION
(* ==================================================================== *)

USES BILDSCHIRM,
     ASCII,
     CRT,
     DISPL;


constructor TWaehler.Init (sp,zei,lae,br, einRahmen : integer ; einTitel : string);
(* -------------------------------------------------------------------- *)

begin
  XPos   := sp;
  YPos   := zei;
  Laenge := lae;
  Hoehe  := br;
  Rahmenart := einRahmen;
  Titel  := einTitel;
  TasteGedrueckt := false;
  FarbeSetzen(WEISS);
  ZeichenfarbeSetzen(HELLGRAU);
end;


procedure TWaehler.Zeigen;
(* -------------------------------------------------------------------- *)
begin
  CFenster.Zeigen;
  Screen.Cursor (XPos+2,YPos+2); write (' 1  - Normaltarif   3.70 ');
  Screen.Cursor (XPos+2,YPos+3); write (' 2  - Kurzstrecke   1.50 ');
  Screen.Cursor (XPos+2,YPos+4); write (' 3  - Sammelkarte  12.50 ');
end;


procedure TWaehler.AuswahlAnzeigen;
(* -------------------------------------------------------------------- *)
var
   i,
   ItemYPos : integer;

begin
      ItemYPos :=  YPos + 1  ;

      for i := 1 to 3 do          (* Tariftarifauswahl durchgehen *)
      begin
        ItemYPos := ItemYPos + 1;

        if Tarif = i
        then
          begin
            if TasteGedrueckt
            then Screen.HintergrundFarbeSetzen (GELB)    (* gewaehlten Tarif markieren *)
            else Screen.NormalVideo;
            Screen.Cursor (XPos+2, ItemYPos) ; write(' ',i,' ');
            Screen.CursorHome;
            Screen.NormalVideo;
          end;
      end; (* for i *)
end;


procedure TWaehler.Eingeben ;
(* -------------------------------------------------------------------- *)
var
  taste   : char;

begin
  Display.Leeren;
  Display.TextZeigen('Bitte Fahrschein whlen');
  AuswahlAnzeigen;

  repeat              (* zugelassene Tasten abfragen *)
    taste := readkey;
    TasteGedrueckt := true;

    case taste of

      chr(ESC) : begin
                   Tarif := 0;
                   Display.TextZeigen('P R O G R A M M A B B R U C H ');
                   delay(3000);
                 end;

      '1'..'3' : begin
                   Tarif := ord(taste) - 48;  (* ASCII-Wert rueckrechnen *)
                   AuswahlAnzeigen ;          (* auf num. Wert *)
                 end

       else       Screen.Beep(1);
    end; (* case *)
  until (taste in ['1'..'3']) or (taste = chr(ESC));

  TasteGedrueckt := false;
end;


function TWaehler.TarifHolen : word;
(* -------------------------------------------------------------------- *)
begin
  TarifHolen := Tarif;
end;


BEGIN
END. (* WAEHLER *)
